#ifndef __SAMYGODCA_INJ_HPP__
#define __SAMYGODCA_INJ_HPP__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <dlfcn.h>
#include <sys/mman.h>

#include "CParsingMedia.hpp"
#include "CMovieCore.hpp"
#include "src/uldAvfdInterfacer.h"
#include "src/spIAe.h"

/* ffmpeg includes */
#include <libavcodec/avcodec.h>

/* libdca includes */
#if HAVE_LIBDCA
#include <libdca/config.h>
#include <libdca/include/dca.h>
#endif

/* libdca library interface */
struct libdca_interface_t {
	dca_state_t * (*dca_init)(uint32_t mm_accel);
	int (*dca_syncinfo)(dca_state_t *state, uint8_t * buf, int * flags,
						int * sample_rate, int * bit_rate, int *frame_length);
	int (*dca_frame)(dca_state_t * state, uint8_t * buf, int * flags,
					level_t * level, sample_t bias);
	void (*dca_dynrng)(dca_state_t * state,
					level_t (* call) (level_t, void *), void * data);
	int (*dca_blocks_num)(dca_state_t * state);
	int (*dca_block)(dca_state_t * state);
	sample_t * (*dca_samples)(dca_state_t * state);
	void (*dca_free)(dca_state_t * state);
	void * hLib_libdca;
	int  initialised;
};
extern struct libdca_interface_t libdca;

#ifdef __cplusplus
extern "C" {
#endif

/* media parsing and handling functions */
extern void CParsingMedia_PrepareParsing(CParsingMedia * Instance);
extern int CParsingMedia_GetMediaTypeInfo(CParsingMedia * Instance, char  const* file_name, Multimedia::_tMediaInfoContext * media_info_context );
extern int CheckSupportMovie( int container, int vcodec, int acodec );
extern int CMovieCore_SetMediaInfo( CMovieCore * , Multimedia::_tMediaInfoContext * );
//extern int CMovieCore_SelectAudio(CMovieCore *, Multimedia::_tMediaInfoContext * , unsigned int );
static void PrepareLibDCA( struct libdca_interface_t * dca, const char * lib_path );

/* avfd audio interface functions */ 
extern int spIAe_Open_DTS( struct avfd_instance_t * avfd , void * result );
extern int spIAe_Close_DTS( struct avfd_instance_t * avfd );
extern int InterfacerContainerAeCopyData_DTS(struct avfd_instance_t * avfd, unsigned char * buffer, int buffsize);
extern int InterfacerAudioTransferData_DTS(struct avfd_instance_t * avfd, int buffsize, int * param3 );
extern int InterfacerAudioTransferDataWithSyncHdr_DTS( struct avfd_instance_t *, int, int, int, int );
extern int InterfacerAudioTransferBufDataWithSyncHdr_DTS( struct avfd_instance_t *, unsigned char *, int, int );

extern int samygodca_init( char * ffmpeg_path, char * logfile );

#ifdef __cplusplus
}
#endif

#endif 
