/*
 * OsaSem.h
 * Copyright (C) 2010 Andreas Fiedler <smartsmurf@users.sourceforge.net>
 *
 * This file is part of samygodca, a free DTS Coherent Acoustics
 * stream decoder plugin for SamyGO extension of Samsung DTV.
 *
 * samygodca is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * samygodca is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __OSASEM_H__
#define __OSASEM_H__

#include <semaphore.h>
#include <pthread.h>

#ifdef __cplusplus
extern "C" {
#endif

int OsaSemGet(sem_t *,int,int);
int OsaSemRelease(sem_t *);
int OsaSemCreate( const char *, int, int, sem_t ** );
int OsaWait( int );
int OsaMutCreate( int dummy, int mutex_type, pthread_mutex_t **mutex );

#ifdef __cplusplus
}
#endif

#endif
